//0=  variable
//1=  short/-Floor_Down/-short  near table low ****GOOD****
//2=   1/ 1/-1           rt/up/bk    CORNER SE UP
//3=   1/ 1/ 1           rt/up/fwd   CORNER NE UP
//4=  -1/ 1/ 1          lft/up/fwd   CORNER NW UP
//5=  -1/ 1/-1          lft/up/bk    CORNER SW UP
//6=   0/ 1/ 1            0/up/fwd   EDGE   N  UP
//7=   1/ 1/ 0           rt/up/0     EDGE   E  UP
//8=  -1/ 1/ 1          lft/up/fwd   EDGE   W  UP
//9=   0/ 1/-1            0/up/bk    EDGE   S  UP
//10=  0/ 1/ 0            0/up/0     CENTER UP        (OVERHEAD)
//11=  1/ Floor_Down/-1  rt/fl/bk    CORNER SE FLOOR
//12=  1/ Floor_Down/ 1  rt/fl/fwd   CORNER NE FLOOR
//13= -1/ Floor_Down/ 1 lft/fl/fwd   CORNER NW FLOOR
//14= -1/ Floor_Down/-1 lft/fl/bk    CORNER SW FLOOR
//15=  0/ Floor_Down/ 1   0/fl/fwd   EDGE   N  FLOOR
//16=  1/ Floor_Down/ 0  rt/fl/0     EDGE   E  FLOOR
//17= -1/ Floor_Down/ 1 lft/fl/fwd   EDGE   W  FLOOR
//18=  0/ Floor_Down/-1   0/fl/bk    EDGE   S  FLOOR
#switch (View)
 #case (0)  #declare loc = < 1.00, (24+Floor_Down)/Focal, (Floor_Span-10)/Focal> #declare Focus_Point=<-Floor_Span, 24+Floor_Down, Floor_Span-10> #break
 #case (1)  #declare loc = < 1.0, -Floor_Down/Focal, -1.0> #break
 #case (2)  #declare loc = < 1.0,  1.0,  -1.0>             #break
 #case (3)  #declare loc = < 1.0,  1.0,   1.0>             #break
 #case (4)  #declare loc = <-1.0,  1.0,   1.0>             #break
 #case (5)  #declare loc = <-1.0,  1.0,  -1.0>             #break
 #case (6)  #declare loc = < 0.0,  1.0,   1.0>             #break
 #case (7)  #declare loc = < 1.0,  1.0,   0.0>             #break
 #case (8)  #declare loc = <-1.0,  1.0,   1.0>             #break
 #case (9)  #declare loc = < 0.0,  1.0,  -1.0>             #break
 #case (10) #declare loc = < 0.0,  1.0,  -0.01>            #break
 #case (11) #declare loc = < 1.0,  Floor_Down/Focal, -1.0> #break
 #case (12) #declare loc = < 1.0,  Floor_Down/Focal,  1.0> #break
 #case (13) #declare loc = <-1.0,  Floor_Down/Focal,  1.0> #break
 #case (14) #declare loc = <-1.0,  Floor_Down/Focal, -1.0> #break
 #case (15) #declare loc = < 0.0,  Floor_Down/Focal,  1.0> #break
 #case (16) #declare loc = < 1.0,  Floor_Down/Focal,  0.0> #break
 #case (17) #declare loc = <-1.0,  Floor_Down/Focal,  1.0> #break
 #case (18) #declare loc = < 0.0,  Floor_Down/Focal, -1.0> #break
#end

camera{
 location Focal * loc
 #debug concat(" Focal * loc = ", str(Focal*loc.x,0,2)," ", str(Focal*loc.y,0,2)," ", str(Focal*loc.z,0,2))
 look_at  Focus_Point
 #debug concat(" FocusPoint = ", str(Focus_Point.x, 0, 2), " ", str(Focus_Point.y,0,2), " ", str(Focus_Point.z,0,2), " ", chr(10))
}

#if (ShowFP=on)

 sphere{<Focus_Point.x, Focus_Point.y, Focus_Point.z>,Focal_Radius
  texture{T_Glass1}
  hollow
 }
 merge{
  cylinder{
   <Focus_Point.x-Focal_Radius, Focus_Point.y, Focus_Point.z>,
   <Focus_Point.x+Focal_Radius, Focus_Point.y, Focus_Point.z>,
   Focal_Radius/8
   texture{T_Ruby_Glass}
  }
  cylinder{
   <Focus_Point.x, Focus_Point.y-Focal_Radius, Focus_Point.z>,
   <Focus_Point.x, Focus_Point.y+Focal_Radius, Focus_Point.z>,
   Focal_Radius/8
   texture{T_Vicksbottle_Glass}
  }
  cylinder{
   <Focus_Point.x, Focus_Point.y, Focus_Point.z-Focal_Radius>,
   <Focus_Point.x, Focus_Point.y, Focus_Point.z+Focal_Radius>,
   Focal_Radius/8
   texture{T_Dark_Green_Glass}
  }
 }

#end

/////////////////////////////////////////////////////
